Unit ZF15R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF10_p;

procedure ZF15R(F :Func_F1; var A :Real; var B :Real; EPS :Real;
                var ROOT :Real; var ITMAX :Integer; var IERR :Integer);

implementation

procedure ZF15R(F :Func_F1; var A :Real; var B :Real; EPS :Real;
                var ROOT :Real; var ITMAX :Integer;
                var IERR :Integer);
var
J1,J2,J3,IT :Integer;
AA,BB,X1,X2,Y,Y1,YA,YB,YTEST,H :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20;
begin
AA := A;
BB := B;
IERR := 0;
ROOT := A;
J1 := 1;
IT := 1;
_1:
Y := F(ROOT);
goto _3;
_2:
A := AA;
B := BB;
if ( IERR <> 0 ) 
 then UTZF10(IERR,15);
goto _20;
_3:
if ( Abs(Y) > Abs(EPS) ) 
 then goto _5;
_4:
IERR := 0;
ITMAX := IT;
goto _2;
_5:
case J1 of
 1: goto _6;
 2: goto _7;
 3: goto _10;
 4: goto _17;
end;
_6:
YA := Y;
ROOT := B;
J1 := 2;
goto _1;
_7:
if ( YA*Y < 0.0 ) 
 then goto _12;
X1 := A;
Y1 := YA;
J1 := 3;
IERR := 66;
H := B-A;
J2 := 1;
_8:
X2 := A+0.5*H;
J3 := 1;
_9:
IT := IT+1;
if ( IT >= ITMAX ) 
 then goto _2;
ROOT := X2;
goto _1;
_10:
if ( YA*Y < 0.0 ) 
 then goto _12;
if ( J3 >= J2 ) 
 then goto _11;
A := ROOT;
YA := Y;
X2 := ROOT+H;
J3 := J3+1;
goto _9;
_11:
A := X1;
YA := Y1;
H := 0.5*H;
J2 := J2+J2;
goto _8;
_12:
B := ROOT;
YB := Y;
J1 := 4;
IERR := 65;
_13:
if ( Abs(YA) <= Abs(YB) ) 
 then goto _14;
X1 := A;
Y1 := YA;
ROOT := B;
Y := YB;
goto _15;
_14:
X1 := B;
Y1 := YB;
ROOT := A;
Y := YA;
_15:
X2 := ROOT-Y*(ROOT-X1)/(Y-Y1);
X1 := ROOT;
Y1 := Y;
YTEST := 0.5*EMin1(Abs(YA),Abs(YB));
if ( (X2-A)*(X2-B) < 0.0 ) 
 then goto _9;
_16:
X2 := 0.5*(A+B);
YTEST := 0.0;
if ( (X2-A)*(X2-B) ) < 0
 then goto _9
 else if ( (X2-A)*(X2-B) ) > 0
       then goto _4
       else goto _4;
_17:
if ( YA*Y >= 0.0 ) 
 then goto _18;
B := ROOT;
YB := Y;
goto _19;
_18:
A := ROOT;
YA := Y;
_19:
if ( YTEST <= 0.0 ) 
 then goto _13;
if ( Abs(Y)-YTEST ) < 0
 then goto _15
 else if ( Abs(Y)-YTEST ) > 0
       then goto _16
       else goto _15;
_20:
end;

end.
